<?php

/**
 * Description of Bitninja
 *
 * @author Joseph Easy
 */
class Bitninja
{

    private static function _buildLogFilesArray()
    {
        $array = array();
	exec("ls /var/log/bitninja/ | grep .log", $logFiles);

        foreach ($logFiles as $logFile) {
            $array[] = array('filename' => $logFile, 'lines' => exec("sed -n '$=' /var/log/bitninja/$logFile"), 'modified' => filemtime("/var/log/bitninja/$logFile"));
        }
        return $array;
    }

    private static function _seperateLog($log)
    {
        $regex = '/\[(?P<log_type>\w+)\] (?P<timezone>(\+|\-)[0-9]{2}:[0-9]{2}) (?P<date>[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}) - ((\|(?P<module>\w+)\| )|)(?P<message>.*)/';
        preg_match($regex, $log, $separatedLog);
        $separatedLog['mtime'] = strtotime($separatedLog['date']);
        if ($separatedLog['log_type'] == 'warn') {
            $separatedLog['color'] = 'orange';
        } else if ($separatedLog['log_type'] == 'error') {
            $separatedLog['color'] = 'red';
        } else {
            $separatedLog['color'] = 'green';
        }
        return $separatedLog;
    }

    public static function getAndBuildLogs()
    {
        $logFilesData = self::_buildLogFilesArray();
        $rawLogs = array();
        $logs = array();
        foreach ($logFilesData as $data) {
            exec('tail /var/log/bitninja/' . $data['filename'] . ' -n 20', $lines);
            $rawLogs = array_merge($lines, $rawLogs);
        }

        foreach ($rawLogs as $log) {
            $logsByLine = explode('\n', $log);
            foreach ($logsByLine as $logLine) {
                $logLine = self::_seperateLog($logLine);
                $logs[$logLine['mtime']] = $logLine;
            }
        }
        krsort($logs);
        return $logs;
        //  return array_slice($logs, 100);
    }

    public static function getVersion()
    {
        $version = exec('apt-cache show bitninja | grep Version', $output, $returnVar);
        if ($returnVar == 0 && $version != '') {
            $version = explode(': ', $version);
            return $version[1];
        } else {
            $version = exec('rpm -qa | grep  bitninja | head -n 1');
            $version = explode('-', $version);
            return $version[1];
        }
    }

    public static function isRun()
    {
        $response = exec('/bin/ps cax | grep bitninja | awk "!/bitninja-/"');
        return $response != null && $response != '';
    }

    public static function start()
    {
        exec('/etc/init.d/bitninja start');
    }

    public static function stop()
    {
        exec('/etc/init.d/bitninja stop');
    }
}
Bitninja::getAndBuildLogs();